/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */


// Function load(): Called by HTML body element's onload event when the web application is ready to start
function load(){
    dashcode.setupParts();
}


// Value Transformer 'ratingToImage': Transforms a rating like 'PG-13' into a URL like '../Images/Rated_PG-13.png'
ratingToImage = Class.create(DC.ValueTransformer,{
    transformedValue: function(value){
		return '../Images/Rated_' + value.replace(/\s/g, '_').toUpperCase() + '.png'; // Replacing spaces with underscores.
    }
});


// Called when switching between the details and video views of the stack layout.
function toggleStackLayout(event){

    // Grab references to the objects we are going to use.
    var videoObject = document.getElementById('video').object;
    var stackLayoutObject = document.getElementById('stackLayout').object;
    var seats = document.getElementById('seats');
    var room = document.getElementById('rightView');
    var spots = document.getElementById('spots');
    
    if (stackLayoutObject.getCurrentView().id == 'detailsView') {
        stackLayoutObject.setCurrentView('videoView');
        
        // Animate seats, spots and background color. With CSS transition, they will slowly fade in & out.
        seats.style.visibility = 'visible';
        seats.style.opacity = 1;
        room.style.backgroundColor = "rgba(0,0,0,0.8)";
        spots.style.opacity = 0;
        
        // Start playing video
        videoObject.play();
        
    } else {
        stackLayoutObject.setCurrentView('detailsView');
        
        // Animate seats, spots and background color. With CSS transition, they will slowly fade in & out.
        seats.style.visibility = 'hidden';
        seats.style.opacity = 0;
        room.style.backgroundColor = "transparent";
        spots.style.opacity = 1;

        if (videoObject.playing())
            videoObject.stop();
    }
}
